package com.nullchat.network;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import com.nullchat.service.ChatMessage;
import com.nullchat.service.Header;

public class NullChatStream extends InputStream {

	InputStream is;

	NullChatStream(InputStream is) {
		this.is = is;
	}

	public ChatMessage readMessage() throws IOException {
		byte size[] = readAll(is, 2);
		byte type[] = readAll(is, 1);

		int i_size = ByteConverter.convertUnsignedByte(size);
		byte data[] = readAll(is, i_size);

		ChatMessage cm = new ChatMessage(data);
		cm.setHeader(new Header(size, type[0]));
		return cm;
	}

	@Override
	public int read() throws IOException {
		return is.read();
	}

	public void close() throws IOException {
		is.close();
	}

	private static byte[] readAll(InputStream is, int size) throws IOException {
		byte[] data = new byte[size];
		int i = 0;

		while (i < size) {
			int j = size - i;
			j = is.read(data, i, j);
			if (j == -1)
				throw new EOFException();
			i += j;
		}
		return data;
	}

}
