package com.nullchat.service;

import com.nullchat.network.ByteConverter;


public class Header {
	private byte[] length = null;
	private byte type;

	public final static byte DEFAULT = 0x00;
	public final static byte POST = 0x01;
	public final static byte ONLINE = 0x02;
	public final static byte ERROR = 0x03;
	public final static byte RADIO = 0x04;
	public final static byte IMAGE = 0x05;
	public final static byte CLEAR = 0x07;

	public Header(byte[] length, byte type) {
		this.type = type;
		this.length = length;
	}

	public Header(byte type) {
		this.type = type;
	}

	public byte[] getBytes() {
		byte[] header = new byte[3];
		header[0] = length[0];
		header[1] = length[1];
		header[3] = type;
		return header;
	}

	public void computeLength(int l) {
		if (length==null)
		length = ByteConverter.convertUnsignedInt(l);
	}

	public byte getType() {
		return type;
	}
}
